package terminal

import java.util.ArrayList

class TerminalHistory {

    private val history: MutableList<String>
    private var lineIndex: Int = 0

    val previousLine: String
        get() = if (isBeginning) history[lineIndex] else history[--lineIndex]

    val isBeginning: Boolean
        get() = lineIndex == 0

    val nextLine: String
        get() = if (isEnd) history[lineIndex] else history[++lineIndex]

    val isEnd: Boolean
        get() = lineIndex == lastIndex()

    init {
        this.history = ArrayList()
        this.history.add("")
        this.lineIndex = 0
    }

    fun addLine(line: String) {
        history[lastIndex()] = line
        history.add("")
        lineIndex = lastIndex()
    }

    private fun lastIndex(): Int {
        return history.size - 1
    }

    fun updateCurrentLine(line: String) {
        history[lineIndex] = line
    }
}
